/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package views;

import javax.swing.table.DefaultTableModel;
import controllers.EstadoController;
import javax.swing.JOptionPane;
/**
 *
 * @author jaimearroyo
 */
public class EstadoIndex extends javax.swing.JFrame {
    DefaultTableModel modelo;
    /**
     * Creates new form CategoryIndex
     */
    public EstadoIndex() {
        initComponents();
        mostrarEstados();
        
    }
    /**
     * Inserta los registros de la base de datos de la tabla Estados en la tabla
     */
    public void mostrarEstados(){
        modelo=new DefaultTableModel();
        modelo.addColumn("ID");
        modelo.addColumn("Estado");
        
        
        EstadoController.index().forEach((p) -> {
            modelo.addRow(p);
        });
        
        idiomas_index.setModel(modelo);
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        header_idioma = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        idiomas_index = new javax.swing.JTable();
        boton_editar = new javax.swing.JButton();
        boton_eliminar = new javax.swing.JButton();
        boton_nuevo = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        header_idioma.setFont(new java.awt.Font("Lucida Grande", 0, 18)); // NOI18N
        header_idioma.setText("Listado de Estados");

        idiomas_index.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(idiomas_index);

        boton_editar.setText("Editar seleccionado");
        boton_editar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                boton_editarActionPerformed(evt);
            }
        });

        boton_eliminar.setText("Eliminar Seleccionado");
        boton_eliminar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                boton_eliminarActionPerformed(evt);
            }
        });

        boton_nuevo.setText("Ingresar Nuevo Estado");
        boton_nuevo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                boton_nuevoActionPerformed(evt);
            }
        });

        jButton1.setText("Volver al inicio");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(124, 124, 124)
                .addComponent(boton_nuevo)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(41, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(header_idioma)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 137, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(boton_eliminar, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(boton_editar, javax.swing.GroupLayout.PREFERRED_SIZE, 166, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 375, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(40, 40, 40))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(8, 8, 8)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(header_idioma)
                    .addComponent(jButton1, javax.swing.GroupLayout.DEFAULT_SIZE, 35, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED, 15, Short.MAX_VALUE)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 275, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(boton_nuevo, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(boton_eliminar, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(boton_editar, javax.swing.GroupLayout.PREFERRED_SIZE, 43, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        pack();
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Evento de captura del boton editar
     * cuando se tiene seleccionada una fila de la tabla se toma el valor y se levanta
     * la vista de edición del estado
     * @param evt evento click en el boton
     */
    private void boton_editarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_boton_editarActionPerformed
        
        EstadoEditNew new_firt_program =new EstadoEditNew();
        EstadoController estado_controller = new EstadoController();
        int row = idiomas_index.getSelectedRow();
        if(row != -1){
            String value = idiomas_index.getModel().getValueAt(row, 0).toString();
            int value_int = Integer.parseInt(value);
            if(estado_controller.get(value_int)){
                this.setVisible(false);
                new_firt_program.set_estado_controller(estado_controller);
                new_firt_program.setVisible(true);
            }else{
                JOptionPane.showMessageDialog( null, "Error al bsucar registro");
            }
            
        }else{
            JOptionPane.showMessageDialog( null, "Debes seleccionar un registro a editar");
        }
        
        
    }//GEN-LAST:event_boton_editarActionPerformed
/**
 * Evento click en el boton eliminar, este gatilla la eliminación
 * del registro en la base de datos seleccionado en la tabla
 * luego se vuelven a renderear la tabla de estados
 * @param evt evento click en el boton
 */
    private void boton_eliminarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_boton_eliminarActionPerformed
                int row = idiomas_index.getSelectedRow();
        if(row != -1){
            String value = idiomas_index.getModel().getValueAt(row, 0).toString();
            int value_int = Integer.parseInt(value);
            EstadoController estado_controller = new EstadoController();
            
            estado_controller.get(value_int);
            
            
            if(!estado_controller.new_record()){
                estado_controller.eliminar();
                JOptionPane.showMessageDialog( null, "El registro ha sido eliminado correctamente");
            }else{
                JOptionPane.showMessageDialog( null, "El registro ya no existe en la base de datos");
            }
            mostrarEstados();
        }else{
            JOptionPane.showMessageDialog( null, "Debes seleccionar una fila a eliminar");
        }
    }//GEN-LAST:event_boton_eliminarActionPerformed
    
    /**
     * Evento click en el boton nuevo estado, esto levanta una nueva vista para crear un estado y oculta la actual
     * @param evt evento click en el boton
     */
    private void boton_nuevoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_boton_nuevoActionPerformed
        EstadoEditNew nueva_estado_view =new EstadoEditNew();
        this.setVisible(false);
        nueva_estado_view.setVisible(true);
    }//GEN-LAST:event_boton_nuevoActionPerformed

     /**
     * Evento click en el boton volver al menu, esto levanta una nueva vista menu y oculta la actual
     * @param evt evento click en el boton
     */
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        Menu new_firt_program =new Menu();
        this.setVisible(false);
        new_firt_program.setVisible(true);
    }//GEN-LAST:event_jButton1ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(EstadoIndex.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(EstadoIndex.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(EstadoIndex.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(EstadoIndex.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new EstadoIndex().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton boton_editar;
    private javax.swing.JButton boton_eliminar;
    private javax.swing.JButton boton_nuevo;
    private javax.swing.JLabel header_idioma;
    private javax.swing.JTable idiomas_index;
    private javax.swing.JButton jButton1;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
}
